#ifndef __DECODER_H__
#define __DECODER_H__

#include "token.h"
#include "feature-set.h"

////////////////////////////////////////////////////////////

class Decoder {
public:
  Decoder(FeatureSet &features) : features(features), D(features.D) { }

  static double find_best_segs(FeatureSet &features, Sequence &seq, SegVec &segs, bool use_averaged, int max_seg_len);
  static double find_best_tags(FeatureSet &features, Sequence &seq, IntVec &tags, bool use_averaged);
  static double find_top2_diff(FeatureSet &features, Sequence &seq, bool use_averaged, int max_seg_len);
  static DoublePair find_top2_scores(FeatureSet &features, Sequence &seq, bool use_averaged, int max_seg_len);

  double find_best_segs_dp(Sequence &seq, SegVec &segs, bool use_averaged, int max_seg_len);
  void find_best_segs_dp_nbest(Sequence &seq, SegVecVec &segss, DoubleVec &scores, bool use_averaged, int max_seg_len, int top_n);

  double find_best_tags_beam(Sequence &seq, IntVec &tags, bool use_averaged);
  void find_best_tags_beam_nbest(Sequence &seq, IntVecVec &tagss, DoubleVec &scores, bool use_averaged, int top_n);

  double find_best_tags_trigram(Sequence &seq, IntVec &tags, bool use_averaged);
  double find_best_tags_bigram(Sequence &seq, IntVec &tags, bool use_averaged);
  double find_best_tags_unigram(Sequence &seq, IntVec &tags, bool use_averaged);

  FeatureSet &features;
  const Domain &D;
};

#endif
