#ifndef __DOMAIN_H__
#define __DOMAIN_H__

#include "basic/strdb.h"
#include "seg-tag.h"

////////////////////////////////////////////////////////////

enum TagDomain { POS, CHUNK, ENT }; // What kind of problem are we solving?

struct Token;

struct Domain {
  Domain(const string &tag_domain_str);
  ~Domain();

  StrDB word_db, tag_db, seg_db;
  StrDB pos_db, chunk_db, ent_db;
  StrDB phrase_db;
  vector<SegTag> stags; // tag (integer) -> corresponding SegTag
  TagDomain tag_domain;
  Token *boundary_token;

  int stag_to_tag(SegTag stag) const;

  void read(const char *file);
  void write(const char *file);

  // Is this a segmentation problem?
  bool is_seg() const { return tag_domain != POS; }

  // Modifies: tag_db, seg_db, stags
  int get_tag(const char *s);
  int get_seg(const char *s);

  int no_seg; // in seg_db
  int no_seg_tag; // in tag_db
};

#endif
