#ifndef __MAP_DB_H__
#define __MAP_DB_H__

#include "basic/stl-basic.h"
#include "basic/strdb.h"

// For each sequence of words, map to a sparse real vector, each feature has a name
// File format:
// sequence of words\tname_1 val_1\tname_2 val_2\tname_3 val_3
class MapDB {
public:
  void read(const char *file, StrDB *phrase_db);

  void get_mapping(const char *s, IntDoubleVec &feature_values) const;
  const char *get_name(int f) const;

  void normalize();

  int size() const { return len(feature_names); }

private:
  typedef hash_map<int, IntDoubleVec> FeatureMap;
  StrDB feature_names; // feature -> feature name
  StrDB *phrase_db;
  FeatureMap map; // phrase -> list of (feature, value) pairs
};

#endif
