#include "basic/std.h"
#include "basic/str.h"
#include "seg-tag.h"

const char *SegTag::no_seg_str = "O";

int SegTag::parse(const char *s, StrDB &db) {
  if(strchr(s, '-')) {
    assert2(strlen(s) >= 3 && s[0] == 'B' || s[0] == 'I' && s[1] == '-', s);
    begin = s[0] == 'B';
    a = db[s+2];
  }
  else {
    begin = true;
    a = db[s];
  }
  return a;
}

string SegTag::str(const StrDB &db) const {
  if(!strchr(db[a], '-')) return db[a];
  return str_printf("%c-%s", begin ? 'B' : 'I', db[a]);
}
