#ifndef __STRENGTH_DB_H__
#define __STRENGTH_DB_H__

#include "basic/stl-basic.h"
#include "basic/strdb.h"

// For each sequence of words, we have a vector of strengths
class StrengthDB {
public:
  void read(const char *file, StrDB &word_db);
  void normalize();

  double get_strength(int w1, int w2, int i) const;
  double get_strength(const IntVec &ws, int i) const;

  int nstrengths;
private:
  IntVecDoubleVecMap strengths_map;
};

#endif
