#include "token.h"

////////////////////////////////////////////////////////////

bool Token::parse(char *s, Domain &D) {
  string str = s;

  // Word
  s = strtok(s, " "); assert2(s, str);
  if(strcmp(s, "-DOCSTART-") == 0) return false;
  word = D.word_db[s];
  assert(word != D.boundary_token->word);

  // Part of speech
  s = strtok(NULL, " "); assert2(s, str);
  pos = D.pos_db[s];
  assert(pos != D.boundary_token->pos);
  if(D.tag_domain == POS) tag = D.get_tag(s);

  // Chunk
  s = strtok(NULL, " "); assert2(s, str);
  chunk.parse(s, D.chunk_db);
  if(D.tag_domain == CHUNK) tag = D.get_tag(s);

  // Named-entity tag
  s = strtok(NULL, " "); assert2(s, str);
  ent.parse(s, D.ent_db);
  if(D.tag_domain == ENT) tag = D.get_tag(s);

  return true;
}

Token *Token::create_special_token(Domain &D, const char *s) {
  Token *t = new Token;
  t->word = D.word_db[s];
  t->tag = D.get_tag(s);
  if(D.is_seg())
    t->seg = Seg(D.get_seg(s), 1);
  t->pos = D.pos_db[s];
  return t;
}
